﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private base As AnchorPane
	Private ancpane As AnchorPane 
	Private flag As Boolean
	Private num_lines,  dy, dx, nw,nh,delta As Int
	Private oldx,oldy As Int
	Dim DataList As List
	Private Tmodule As Object
	Private TText, TRoot, Tstyle As String
	Private rootnode, nd() As TreeNode
	Dim dx, dx, nw, nh As Int
	Dim Path As String
	
Type Data(Text As String,Tag As String, Tag1 As Boolean, Textcolor As Paint, img As Image)
End Sub

'Initializes the object.
'Module is the launching module (pass Me), style may contain the background color for the treepane and the r\treenodes.
'deltax and deltay are the difference in placing of child nodes.
'NodeWidth and NodeHeight are the complete node's width and height.
'Width and Height are the size measures of the treepane.
'PicPath is the path for the pictures.
Public Sub Initialize(Module As Object, Eventname As String, style As String, deltax As Int, deltay As Int, NodeWidth As Int, NodeHeight As Int,Width As Int, Height As Int)
Tmodule = Module
base.Initialize("base")
base.PrefWidth = Width
base.PrefHeight = Height
Tstyle = style
base.style = style
ancpane.Initialize("ancpane")
base.AddNode(ancpane,0,0,Width,Height)
ancpane.Visible = True
Tstyle = style
dx = deltax
dy = deltay
nw = NodeWidth 
nh = NodeHeight 
DataList.Initialize
End Sub

Public Sub AsNode As Node
Return base
End Sub

'Sets the root node. Pass Null if no image.
Public Sub SetRoot(Root As String,Text As String, TextColor As Paint, img As Image)
TText = Text
TRoot = Root
rootnode.Initialize(Me,Null,0,TText,img ,TRoot,True,Tstyle,TextColor, 0, 10 )
ancpane.AddNode(rootnode.AsNode,0,10, nw,nh)
num_lines = 1
End Sub

'Used by the TreeNode mudule.
Public Sub Node_open(tnode As TreeNode)
Dim Da As Data
If SubExists(Main,"GetData") Then
	DataList.Initialize
	CallSub3(Tmodule,"GetData",Me,tnode.TN.tag)
Else
	Return
End If
If DataList.IsInitialized = False Then Return
Dim nd(DataList.Size) As TreeNode
num_lines = num_lines + DataList.Size
move_nodes( tnode.AsNode.top ,DataList.Size)
For i = 0 To DataList.Size-1         ' assign data items to new nodes
	Da = DataList.Get(i)
	Dim iconimg As Image
	If Da.img <> Null  Then
		iconimg = Da.img
	Else
		iconimg = Null
	End If
	
	nd(i).Initialize(Me,tnode,tnode.TN.level + 1,Da.Text,iconimg,Da.tag,Da.Tag1,Tstyle, Da.Textcolor,tnode.TN.p.left + dx,tnode.TN.p.top+dy*(i+1) )
	ancpane.Addnode(nd(i).AsNode, tnode.TN.p.left + dx,tnode.TN.p.top+dy*(i+1),nw,nh)
Next
End Sub

'Used by the TreeNode mudule.
Public Sub Node_Close(tnode As TreeNode)
Dim mx As Int
Dim v As Node
delta = 0   ' a counter for collapsed lines       
remove_children(tnode)
move_nodes( tnode.AsNode.top ,-delta) ' move lower nodes up
mx = 0  
For i = 0 To ancpane.NumberOfNodes - 1 
	v = ancpane.GetNode(i)
	mx = Max(mx,v.Left+nw)	
Next
End Sub

Private Sub remove_children(Rnode As TreeNode)  ' close a node
num_lines = num_lines - Rnode.TN.children.Size
For i =  Rnode.TN.children.Size - 1 To 0 Step - 1
	delta = delta + 1
	Dim t As TreeNode = Rnode.TN.children.Get(i)
	If t.TN.children.Size > 0 Then remove_children(t) ' recursion if the sub node has children
	t.TN.p.RemoveNodeFromParent  ' then delete it
Next
Rnode.TN.children.Clear  ' zero the child list in the closing node
End Sub

'Gets the MouseClick event from the sender nose and pass it to the calling Module.
Public Sub Node_Click(tnode As TreeNode)
If SubExists(Tmodule,"NodeClicked") Then
	CallSubDelayed3(Tmodule,"NodeClicked",Me,tnode.TN.tag)
End If
End Sub

Private Sub move_nodes( top As Int,lines As Int)
Dim v As Node
For j = 0 To ancpane.NumberOfNodes - 1  
	v = ancpane.GetNode(j)
	If v.top  > top Then
		v.top = v.top + lines * dy
	End If
Next
End Sub

Private Sub base_MouseDragged (EventData As MouseEvent)
If flag Then
	ancpane.Left = Min(ancpane.Left + EventData.X - oldx, 0)
	ancpane.Top = Min(ancpane.Top + EventData.y - oldy,0)
	oldx = EventData.X
	oldy = EventData.Y
End If	
End Sub

Private Sub base_MousePressed (EventData As MouseEvent)
flag = True
oldx = EventData.X
oldy = EventData.Y	
End Sub

Private Sub base_MouseReleased (EventData As MouseEvent)
flag = False	
End Sub

